"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const serviceLifetime_1 = require("../serviceLifetime");
const resolveDependency_1 = require("./resolveDependency");
const get_1 = require("./get");
const set_1 = require("./set");
function getOrResolve(collection, dependency, resolver) {
    return new Promise((resolve, reject) => {
        const existingValue = get_1.default(collection, dependency);
        if (resolver === undefined || existingValue !== undefined) {
            resolve(existingValue);
            return;
        }
        const resolveFunc = (value, lifetime = serviceLifetime_1.default.Transient, tags = []) => {
            set_1.default(collection, dependency, value, lifetime, tags);
            const resolvedDependency = resolveDependency_1.default(value, lifetime);
            resolve(resolvedDependency);
        };
        resolver(dependency, resolveFunc);
    });
}
exports.default = getOrResolve;
//# sourceMappingURL=getOrResolve.js.map